import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import javax.jcr.LoginException;
import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.nodetype.NodeType;

import org.infinispan.schematic.document.ParsingException;
import org.modeshape.jcr.JcrRepository;
import org.modeshape.jcr.ModeShapeEngine;
import org.modeshape.jcr.NoSuchRepositoryException;
import org.modeshape.jcr.RepositoryConfiguration;

public class ClusterMain {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		JcrRepository jcrRepository0 = deployRepo();

		JcrRepository jcrRepository1 = deployRepo();

		Session session = null;
		try {
			session = jcrRepository1.login();
			Node rootNode = session.getRootNode();
			Node fileNode = rootNode.addNode("dupa", NodeType.NT_FILE);
			Node resourceNode = fileNode.addNode("jcr:content",
					NodeType.NT_RESOURCE);

//			FileInputStream inputStream = new Byt

			resourceNode.setProperty("jcr:data", "");
			session.save();

		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RepositoryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if (session != null) {
				session.logout();
			}
		}

	}

	private static JcrRepository deployRepo() throws ParsingException,
			FileNotFoundException, RepositoryException,
			NoSuchRepositoryException, InterruptedException, ExecutionException {
		RepositoryConfiguration repositoryConfiguration = RepositoryConfiguration
				.read("src/main/resources/configRepository.json");
		ModeShapeEngine engine = new ModeShapeEngine();
		engine.start();

		engine.deploy(repositoryConfiguration);
		Future<JcrRepository> future = engine.startRepository("webdav_repo");
		JcrRepository jcrRepository = future.get();
		System.out.println("started -> " + future.get());
		return jcrRepository;
	}
}
